unit Server.Resources.Counter;

interface

uses
  System.SysUtils, System.Classes, System.SyncObjs,

  WiRL.Core.JSON,
  WiRL.Core.Registry,
  WiRL.Core.Attributes,
  WiRL.http.Accept.MediaType,
  WiRL.http.URL,
  WiRL.http.Request,
  WiRL.Core.MessageBody.Default,
  WiRL.Data.MessageBody.Default,
  WiRL.Core.Exceptions;

type
  [Path('/counter')]
  TCounterResource = class(TObject)
  public
    [GET]
    function GetCounter: Integer;

    [POST]
    function IncCounter: Integer;
  end;

var
  Counter: Integer = 0;
  Lock: TCriticalSection;

implementation

{ TCounterResource }

function TCounterResource.GetCounter: Integer;
begin
  Result := Counter;
end;

function TCounterResource.IncCounter: Integer;
begin
  Lock.Acquire;
  try
    Inc(Counter);
    Result := Counter;
  finally
    Lock.Release;
  end;

  //AtomicIncrement(Counter);
  //TInterlocked
end;

initialization
  TWiRLResourceRegistry.Instance.RegisterResource<TCounterResource>;

  Lock := TCriticalSection.Create;

finalization

  Lock.Free;

end.
