unit Server.Resources.Data;

interface

uses
  System.SysUtils, System.Classes, System.JSON, System.DateUtils, Data.DB,
  Variants, Windows, Datasnap.DBClient,

  WiRL.Core.JSON,
  WiRL.Core.Registry,
  WiRL.Core.Attributes,
  WiRL.http.Accept.MediaType,
  WiRL.http.URL,
  WiRL.http.Request,
  WiRL.Core.MessageBody.Default,
  WiRL.Data.MessageBody.Default,
  WiRL.Core.Exceptions,
  WiRL.Data.Resolver,

  Server.Database.Data;

type
  [Path('/main')]
  TMainModule = class(TObject)
  private
    FDMData: TDMData;
  public
    [GET, Path('/employee/')]
    [RolesAllowed('users')]
    function Employee([QueryParam] const filter: string): TDataSet;

    [GET, Path('/test.html')]
    function EmployeeHTML([QueryParam] const filter: string): string;

    [POST, Path('/employee/')]
    function InsertEmployee([BodyParam] Json: TJSONValue): TJSONObject;

//    [PUT, Path('/employee/{Id}')]
//    function UpdateEmployee([BodyParam] Json: TJSONValue): TJSONObject;
//
//    [DELETE, Path('/employee/{Id}')]
//    function DeleteEmployee([PathParam] Id: Integer; [BodyParam] Json: TJSONValue): TJSONObject;

    constructor Create;
    destructor Destroy; override;
  end;

var
  MainModule: TMainModule;

implementation

{ TMainModule }

function TMainModule.Employee([QueryParam] const filter: string): TDataSet;
begin
  Result := FDMData.GetEmployee(filter);
end;

function TMainModule.EmployeeHTML(const filter: string): string;
var
  LDataSet: TDataSet;
begin
  LDataSet := FDMData.GetEmployee(filter);

  LDataSet.Open;
  while not LDataSet.Eof do
  begin
    Result := Result +
      '<tr>' +
        '<td>' + LDataSet.FieldByName('FIRST_NAME').AsString + '</td>' +
        '<td>' + LDataSet.FieldByName('LAST_NAME').AsString + '</td>' +
      '</tr>' + sLineBreak;
    LDataSet.Next;
  end;
  Result := '<html><table>' + sLineBreak + Result + '</table></html>';
end;

function TMainModule.InsertEmployee(Json: TJSONValue): TJSONObject;
begin
  raise EWiRLNotImplementedException.Create('Not yet implemented');
end;

constructor TMainModule.Create;
begin
  FDMData := TDMData.Create(nil);
end;

destructor TMainModule.Destroy;
begin
  FDMData.Free;
  inherited;
end;

initialization

  TWiRLResourceRegistry.Instance.RegisterResource<TMainModule>;

end.
