Ext.define('MyApp.view.employee.List', {
    extend: 'Ext.Panel',
    xtype: 'employee-list',

    controller: 'employee-list',

    title: 'Employee',

    layout: 'fit',

    tools: [
        { iconCls: 'x-fas fa-cog', handler: 'onNewJobClick' },
        { iconCls: 'x-fa fa-plus', handler: 'onAddClick' },
        { iconCls: 'x-fas fa-eye', handler: 'onShowClick' }

    ],

    items: [{
        xtype: 'textfield',
        label: 'Filter',
        margin: 5,
        docked: 'top',
        labelTextAlign: 'right'
    },
    {
        xtype: 'grid',
        store: {
            autoLoad: true,
            model: 'MyApp.model.Employee'
        },
    
        columns: [{ 
            text: 'First name', 
            dataIndex: 'FIRST_NAME', 
            flex: 1 
        }, { 
            text: 'Last name', 
            dataIndex: 'LAST_NAME', 
            flex: 1, 
            tpl: '<b>{LAST_NAME:htmlEncode}</b>', 
            cell: {
                encodeHtml: false
            } 
        }, { 
            text: 'Phone ext.', 
            dataIndex: 'PHONE_EXT', 
            flex: 1 
        }, { 
            text: 'Hire date', 
            dataIndex: 'HIRE_DATE', 
            flex: 1, 
            xtype:'datecolumn', 
            format:'d/m/Y' 
        }, { 
            text: 'Salary', 
            dataIndex: 'SALARY', 
            flex: 1, 
            xtype: 'numbercolumn', 
            format:'0.00', 
            align: 'right' 
        }]    
    }]
});
