Ext.define('MyApp.view.job.JobView', {

    extend: 'Ext.Panel',
    xtype: 'job-list',

    title: 'Jobs',

    tools: [{
        iconCls: 'x-fas fa-sync',
        handler() {
            this.up('panel').down('grid').getStore().load();
        }
    }],

    layout: 'fit',

    items: [{
        xtype: 'grid',
        store: {
            autoLoad: true,
            model: 'MyApp.model.Job'
        },
    
        columns: [{
            text: 'Status', 
            dataIndex: 'status', 
            tpl: '<span style="color:{[values.status === "S" ? "red" : "blue"]}" class="x-fas fa-circle"></span> {status}',
            cell: {
                encodeHtml: false
            }
        },{ 
            text: 'Id', 
            dataIndex: 'id',
        }, { 
            text: 'Params', 
            dataIndex: 'params'
        }]    
    }]
});
