Ext.define('MyApp.view.main.LoginViewController', {
    extend: 'Ext.app.ViewController',
    alias: 'controller.app-login',

    onLogin() {
        //console.log(this.form.getValues());
        Ext.Ajax.request({
            url: 'rest/default/auth',
            params: this.form.getValues(),
            success(operation) {
                const response = Ext.decode(operation.responseText);
                Ext.Ajax.setDefaultHeaders({
                    Authorization: 'Bearer ' + response.access_token
                });
                this.getView().close();
                Ext.Viewport.add({
                    xtype: 'app-main'
                });
            },
            failure() {
                Ext.Msg.alert('Error', 'Argh!!!');
            },
            scope: this
        });
    },

    onGetPassword() {
        Ext.Ajax.request({
            method: 'GET',
            url: 'rest/default/auth/passhash',
            params: this.form.getValues(),
            success(operations) {
                Ext.Msg.alert('HashPassword', operations.responseText);
            },
            failure() {
                Ext.Msg.alert('Error', 'Argh!!!');
            },
            scope: this
        });

    },

    init() {
        this.form = this.getView().down('formpanel');
    }
});